<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Module: a_index_server</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Module: a_index_server</h1>

    




<section>

<header>
    
        
            
        
    
</header>

<article>
    <div class="container-overview">
    
        
            <div class="description"><h2>Main module</h2>
<p> This is the module description of the index.js main module in node.js. The project goal is to provide models, simulations
and controls methods for vehicle fleets. It starts out with a simulation environment of a static engine model. To understand the
details about the static engine model see <a href="tutorial-staticEngineModel.html">Static combustion engine model</a></p>
<h3>Webservers and clients of this application</h3>
<table>
<thead><tr><th>Servers</th><th>Clients</th></tr></thead>
<tr><td>Postgres</td> <td>node.js, jupyter</td></tr>
<tr><td>Node.js</td> <td>Web Browser : calibration views + stimulation & simulation view + static code view</td></tr>
<tr><td>Jupyter</td> <td>Jupyter Notebooks</td></tr>     
</table>
<p> The project currently uses 3 docker containers: </p>
<li>node.js container : calibration data and simulation control interface</li>
<li>jupyter server and jupyter notebook container : static and dynamic engine models</li>
<li>postgres container : database server for all needed by node and jupyter</li>
<p>Continue reading this page to understand the details of the node.js container</p>
<h3>Web Clients</h3>
<p>To understand the concept of this main server module it is necessary to understand the web clients.
Find the overview in the web clients tutorial.<a href="tutorial-webclients.html">webclients</a></p>
<h3>Parent module</h3>
<p> This is the top level module. There is no parent module.</p>
<h3>Child modules</h3>
<p>A socketIO module is attached to the http server. Follow the attached link to find the details for the socket module : </p>
<p>See <a href="module-c_socketCom_server.html"><code>module:c_socketCom_server</code></a></p>
<h3>Clients and servers of this module</h3>
<table>
<thead><tr><th>Client</th><th>Table in Postgres Server</th><th>Description</th></tr></thead>
<tr><td>/</td> <td>ThermoBaseDataStationary</td><td>All engine parameters are described by JSONB information in table columns</td></tr>
<tr><td>/</td> <td>ThermoCalDataCurves</td><td>Data table for constants : Editors for constants are opened up in main view once a constant is selected</td></tr>
<tr><td>/signals</td> <td>not yet defined</td><td>simulation view is currently under development</td></tr>
<tr><td>/Tree</td> <td>not yet defined</td><td>static code analysis is under development</td></tr>
<tr><td>/editsurface</td> <td>ThermoCalDataMaps</td><td>data table for 3d edtor</td></tr>
<tr><td>/editcurve</td> <td>ThermoCalDataCurves</td><td>load 2d graphical curve editor</td></tr>
<tr><td>/docs</td> <td>no data tables used</td><td>currently no documentation data is stored in postgres</td></tr>     
</table>   
<p>The table shows the postgres data which is read and changed by the client calls according to the path shown in the first column</p>
<p>Index.js is the main node.js module. It controls the following views : 
<li>select and activate the below views (exception : editing calibration constants happens in the same view)</li>
<li>3d map editor</li>
<li>2d curve editors specialized in engine characteristics</li>
<li>simulation</li>
<li>static code analysis + placement of bypass and measurement hooks</li>
<br>
"npm run start" activates the module.
It starts an http server on the given host at port 3000 or a port which is defined by 
the environment variable PORT.env. A socket connection is attached to the http server.
Major goal of the socket is the communication from an to a postgres database 
which stores all project related data. </p>
<p> The router of a node express application is coordinating requests received from the 
 client </p>
<p>The index.js main module provides the following services : </p> 
<li>provide a set of public folders which may be accessed by client http requests</li>
<li>routing for http get and post requests</li>
<li>continuous client/server communication via socket.IO</li>
<p> Members :  </p>
<li> app_use : defines the public folders,the view engine, the router path </li>
<li> socketCom : controls the socketIO communication between client and server </li>
<li> path : controls the socketIO communication between client and server </li>
<li> server : controls the socketIO communication between client and server </li>
<li> router : controls the socketIO communication between client and server </li>
<li> express : controls the socketIO communication between client and server </li>
<p> Methods :  </p>
<li> app_set() : defines pug as the view engine and the views folder as the location of views </li>
<li> app_use() : defines the public folders and their path names </li>
<li> bodyParser() : parses the http request bodies </li>
<li> router_get() : http get service function </li>
<li> router_post() : http post service function </li>
<li> socket_com() : http post service function </li>
<li> server_listen() : activates the listener of the server</li>
<p>The main module creates and activates the http server. It coordinates the http get and post
routes.</p></div>
        

        
            















<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line245">line 245</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
    
    </div>

    

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id="~app"><span class="type-signature">(inner, constant) </span>app<span class="type-signature"> :<a href="express.html">express</a></span></h4>




<div class="description">
    <p>Create the application object</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type"><a href="express.html">express</a></span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line334">line 334</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="~express"><span class="type-signature">(inner, constant) </span>express<span class="type-signature"> :class</span></h4>




<div class="description">
    <p>Load framework class</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">class</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line329">line 329</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="~path"><span class="type-signature">(inner, constant) </span>path<span class="type-signature"> :object</span></h4>




<div class="description">
    <p>get path object from path module</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line344">line 344</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="~router"><span class="type-signature">(inner, constant) </span>router<span class="type-signature"> :<a href="router.html">router</a></span></h4>




<div class="description">
    <p>get router module</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type"><a href="router.html">router</a></span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line354">line 354</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="~server"><span class="type-signature">(inner, constant) </span>server<span class="type-signature"> :httpserver</span></h4>




<div class="description">
    <p>create http server object out of the application object</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">httpserver</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line339">line 339</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="~socketCom"><span class="type-signature">(inner, constant) </span>socketCom<span class="type-signature"> :object</span></h4>




<div class="description">
    <p>get socket object with socket communication method from socketCom module</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line349">line 349</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id="~app_set"><span class="type-signature">(inner) </span>app_set<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Set folder any type of view engine :</p>
<p> folder : ./views
<p> view engine : pug
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line385">line 385</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~app_use"><span class="type-signature">(inner) </span>app_use<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Define public folder and route names :</p>
<table>
<thead><tr><th>access from client</th><th>path on host</th><th>description</th></tr></thead>
<tr><td>/HTML</td> <td>__dirname + /HTML</td><td>contains all HTML client pages</td></tr>
<tr><td>/View</td> <td>__dirname + /View</td><td>contains the pug view engine source code</td></tr>
<tr><td>/Script</td> <td>__dirname + /Script</td><td>contains all javascript sources for the HTML pages</td></tr>
<tr><td>/testdata</td> <td>__dirname + /testdata</td><td>contains the model stimulation data</td></tr>
<tr><td>/images</td> <td>__dirname + /images</td><td>contains pictures in png format</td></tr>
<tr><td>/docs</td> <td>__dirname + /docs</td><td>contains the documentation pages in HTML</td></tr>     
</table>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line355">line 355</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~bodyParser"><span class="type-signature">(inner) </span>bodyParser<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Parses HTML structure sent by a http post request</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line407">line 407</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~pgGetFnc"><span class="type-signature">(inner) </span>pgGetFnc<span class="signature">('ActiveView')</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>The active view postgres interface is used by the 'submit' post request.
Depending on the status of the 'ActiveView' information in postgres the post request
is redirected in the following way : <br></p>
<li>'ActiveView' equals 'map' : &nbsp;&nbsp;&nbsp;&nbsp;<a href="module-a_index_server.html#~response_redirect_m"><code>redirect 3d map editor</code></a></li>
<li>ActiveView' equals 'curve' :&nbsp;&nbsp;&nbsp;&nbsp;<a href="module-a_index_server.html#~response_redirect_c"><code>redirect 2d curve editor</code></a></li>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>'ActiveView'</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>'constant','map','curve'</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line532">line 532</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~response_redirect_c"><span class="type-signature">(inner) </span>response_redirect_c<span class="signature">('/editcurve')</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>'ActiveView' status is equal to 'curve'
the 2d editing view is activated by redirecting the post
request.
<br><br><a href="module-a_index_server.html#~router_get_ec"><code>see get request for edit curve</code></a></p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>'/editcurve'</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>redirects node express router to the
/editsurfe url path.</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line563">line 563</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~response_redirect_m"><span class="type-signature">(inner) </span>response_redirect_m<span class="signature">('/editsurface')</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>'ActiveView' status is equal to 'map'
the 3d editing view is activated by redirecting the post
request.
<br><br><a href="module-a_index_server.html#~router_get_es"><code>see get request for edit surface</code></a></p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>'/editsurface'</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>redirects node express router to the
/editsurfe url path.</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line549">line 549</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_get_d"><span class="type-signature">(inner) </span>router_get_d<span class="signature">(/)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>By inserting the url path of this server together with the root path (&quot;/&quot;) into the browser
address bar and pressing return, the browser sends a get request for the path &quot;/&quot; to the server. The server
replies by loading the '/HTML/dispatcher.html' file into the web client. On the reply the browser starts
to render the html file and executes the included javascript. Find more details about the client by following
the link. <br><br>
<a href="b_create_caldata_buttons_client.b_1_dataviz.html"><code>client : load and start function selection view</code></a></p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>root path</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line417">line 417</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_get_dc"><span class="type-signature">(inner) </span>router_get_dc<span class="signature">(/docs)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>load /docs/index.html which creates the
documentation view</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/docs</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>url path</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line489">line 489</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_get_ec"><span class="type-signature">(inner) </span>router_get_ec<span class="signature">(/editcurve)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>replies on the get request by sending /HTML/editableSurface.html
to the client. The html creates the 3d map visualization.
<br><a href="module-m_curveGraphGenerator_client.html"><code>2d visualization</code></a></p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/editcurve</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>url path</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line476">line 476</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_get_es"><span class="type-signature">(inner) </span>router_get_es<span class="signature">(/editsurface)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>replies on the get request by sending /HTML/editableSurface.html
to the client. The html creates the 3d map visualization.
<br><a href="module-l_3d_map_visualization_client.html"><code>3d visualization</code></a></p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/editsurface</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>url path</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line463">line 463</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_get_s"><span class="type-signature">(inner) </span>router_get_s<span class="signature">(/signals)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>HTTP get service signals</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/signals</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>signals</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line435">line 435</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_get_t"><span class="type-signature">(inner) </span>router_get_t<span class="signature">(/tree)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>get request service on url path /tree. Replies by
sending d3treeAnimated.html, which creates the static
is sent to</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/tree</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>d3treeAnimated.html does not use any
external javascript codes yet. This view uses json documents
and javascript code which is directly embedded into the html
for demonstration purposes.</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line446">line 446</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_post"><span class="type-signature">(inner) </span>router_post<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>HTTP post service</p>
<p> - client HTML information sent by the post request is parsed
and the HTML page is redirected to a destination route according
to a request information which is contained in the HTML 
The post requests of this application are sent by submit buttons 
in client HTML forms</p>
<p>Routes :</p>
<table>
  <tr><th>path req. client</th><th>ActiveView == 'map'</th><th>ActiveView == 'curve'</th><th>Description</th></tr>
  <tr><td>/submit</td> <td>/editsurface</td><td>/editcurve</td><td>Redirect request to corresponding graphical editor</td></tr>
  <tr><td>/signals</td> <td>/signals</td><td>/signals</td><td>Redirect to stimulation view</td></tr>
  <tr><td>/staticcode</td> <td>/tree</td><td>/tree</td><td>Redirect tree view for static code analysis</td></tr>
</table>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line501">line 501</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_post_sbm"><span class="type-signature">(inner) </span>router_post_sbm<span class="signature">(/submit, urlencodedParser, function())</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>HTTP post on path 'submit' is triggered by pressing the submit button in an input form of
the function selection view. The http post service is checking the status of an active
view flag before it activates either a 3d map editor or a 2d map editor. <br><br>
Find details about the decision logic in <br> <a href="module-a_index_server.html#~pgGetFnc"><code>get active view from postgres</code></a></p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/submit</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>urlencodedParser</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>function()</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            

            <td class="description last"><p><a href="module-a_index_server.html#~pgGetFnc"><code>get active view from postgres</code></a></p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line520">line 520</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_post_sig"><span class="type-signature">(inner) </span>router_post_sig<span class="signature">(/signals, urlencodedParser, redirect_s)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>HTTP get service signals</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/signals</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>urlencodedParser</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>redirect_s</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            

            <td class="description last"><p>Redirects the 'signals' post request to the 'signals'
get request.
<br><a href="module-a_index_server.html#~router_get_s"><code>see get request for signals</code></a></p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line578">line 578</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~router_post_stc"><span class="type-signature">(inner) </span>router_post_stc<span class="signature">(/staticcode, urlencodedParser, function())</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>HTTP get service static code</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>/staticcode</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>urlencodedParser</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>function()</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            

            <td class="description last"></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line594">line 594</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~server_listen"><span class="type-signature">(inner) </span>server_listen<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>The server starts listening to a defined port and host</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line610">line 610</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="~socketCom"><span class="type-signature">(inner) </span>socketCom<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>see <a href="module-c_socketCom_server.html"><code>module:c_socketCom_server</code></a></p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="index.js.html">index.js</a>, <a href="index.js.html#line399">line 399</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>